/* automaticky budik
 * by Marek Zelem (c)13.10.1998
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <mmm/text.h>
#include <mmm/net_lib.h>
#include "computer.h"

typedef struct budik_s	{
	struct budik_s *next;
	time_t	time;
	char user[32];
			} budik_t;

static budik_t	*budiktab;

static int set_budik( char *user, time_t time )
{ budik_t *b,*n;
  int fd;
  char buf[1024];
	if( (n=malloc(sizeof(budik_t)))==NULL )
		return(-1);
	if( strlen(user)>31 )	user[31]=0;
	n->time=time;
	strncpy(n->user,user,32);	n->user[31]=0;
	if( (b=budiktab)==NULL || b->time > time )
	{	n->next=budiktab;
		budiktab=n;
	}
	else
	{	while( b->next!=NULL && b->next->time<=time )
			b=b->next;
		n->next=b->next;
		b->next=n;
	}
	sprintf(buf,"budik:%s:%ld",user,time);
	fd=open(buf,O_WRONLY|O_CREAT|O_EXCL,0600);
	if( fd>=0 )	close(fd);
	alarm(1);
	return(0);
}

static int clr_budik( char *user, time_t time )
{ budik_t *b,**p;
  char buf[1024];
	if( strlen(user)>31 )	user[31]=0;
	b=budiktab;	p=&budiktab;
	while( b!=NULL && b->time<=time )
	{	if( b->time==time && !strcmp(b->user,user) )
		{	*p=b->next;
			free(b);
			sprintf(buf,"budik:%s:%ld",user,time);
			unlink(buf);
			return(0);
		}
		p=&(b->next);
		b=b->next;
	}
	return(-1);
}

/* obsluha signalu */

static int budik_tell( char *user, time_t t )
{
	if( fork()==0 )
	{ time_t acttime;
	  char *av[8];
	  char ct[128];
	  char buf[1024];
	  	acttime=time(NULL);
		strcpy(ct,ctime(&t));
		if( ct[0]!=0 && ct[strlen(ct)-1]=='\n' )
			ct[strlen(ct)-1]=0;
		if( t + 30 < acttime )	/* asi nieco zlyhalo */
			sprintf(buf,"Chceli ste aby sme Vas zobudili o %s. Ospravedlnte prosim zmeskanie sposobene pravdepodobne rebootom systemu.",ct);
		else
			sprintf(buf,"Chceli ste aby sme Vas zobudili o %s",ct);
		av[0]="tell";
		av[1]="-t";
		av[2]="budik";
		av[3]=user;
		av[4]=buf;
		av[5]=NULL;
		close(0); close(1); close(2);
		setuid(2);
		execv(av[0],av);
		execv("./tell",av);
		execv("/usr/local/bin/tell",av);
		execv("/usr/bin/tell",av);
		exit(-1);
	}
	return(0);
}

void alarm_handler( int signum )
{ budik_t *b;
  time_t t;
	if( (b=budiktab)!=NULL )
	{	t=time(NULL);
		while( b!=NULL && b->time<=t )
		{	budik_tell(b->user,b->time);
			clr_budik(b->user,b->time);
			b=budiktab;
		}
		if( b!=NULL )
		{	alarm(b->time - t);
		}
	}
	signal(signum,alarm_handler);
}

/* inicializacia */

static int budik_reinit( void )
{ DIR *d;
  struct dirent *de;
  int i,j;
  time_t t;
  char buf[1024];
  	if( (d=opendir("."))==NULL )
		return(-1);
	while( (de=readdir(d))!=NULL )
	{	if( !strncmp(de->d_name,"budik:",6) )
		{	i=6; j=0;
			while( de->d_name[i]!=0 && de->d_name[i]!=':' )
				buf[j++]=de->d_name[i++];
			buf[j]=0;
			if( de->d_name[i]==0 )	continue;
			i++;
			t=atol(&(de->d_name[i]));
			if( t==0 )	continue;
			set_budik(buf,t);
		}
	}
	closedir(d);
	return(0);
}

int budik_init( void )
{
	budik_reinit();
	signal(SIGALRM,alarm_handler);
	alarm(1);	/* nastarovanie */
	return(0);
}

int budik_func( int sock, char *input )
{ darg_t *sout;
  ddata_t *iout;
  time_t t,tt;
  struct tm tm,*p;
  int *i,r;
  	t=time(NULL);
	p=localtime(&t);	tm=*p;
	if( !strstr(input,"budik") && !strstr(input,"zobud") )
		return(0);
	r=0;
	if( arg_parse(
	"%[a-zA-Z0-9@_\\-]\":\"[:\"[,a-z.?:;%&\t ]\":][[%M\" \"]%d\" \"]%d\":\"%d[\":\"%d]"
		,&input,&sout,&iout) >0 )
	{	i=dd_data(iout);
		tm.tm_hour=i[2];
		tm.tm_min=i[3];
		if( i[4]>=0 )	tm.tm_sec=i[4];
		else		tm.tm_sec=0;
		if( i[1]>0 )	tm.tm_mday=i[1];
		if( i[0]>=0 )	tm.tm_mon=i[0];
		tt=mktime(&tm);
		if( t<=tt )
		{	if( !strstr(input,"zrus") )
			{
			net_printf(sock,"Budik nastaveny na: %s",ctime(&tt));
			set_budik(darg_argv(sout)[0],tt);
			}
			else
			{  if( clr_budik(darg_argv(sout)[0],tt)<0 )
				net_printf(sock,"Lutujem ale takyto budik nastaveny nebol.\n");
			   else
				net_printf(sock,"Budik zruseny.\n");
			}
		}
		else
			net_printf(sock,"Lutujen ale toto je uz minulostou: %s",ctime(&tt));
		r=1;
	}
	else
	{	net_printf(sock,"Zly format ziadosti! ( [[Month] Day] <Hour>:<min>[:<sec>] )\n");
		r=1;
	}
	arg_parse_free(&sout,&iout);
	return(r);
}
 
